Program FraktaleKurven ;

Uses Crt , Graph , RLTurtle ;

Procedure Hilbert ( Grad , Seite , Richtung : Integer ) ;

Begin
  If Grad > 0 Then
  Begin
    TurnRight ( Richtung * 90 ) ;
    Hilbert ( Grad - 1 , Seite , - Richtung ) ;
    Forwd ( Seite ) ;
    TurnLeft ( Richtung * 90 ) ;
    Hilbert ( Grad - 1 , Seite , Richtung ) ;
    Forwd ( Seite ) ;
    Hilbert ( Grad - 1 , Seite , Richtung ) ;
    TurnLeft ( Richtung * 90 ) ;
    Forwd ( Seite ) ;
    Hilbert ( Grad - 1 , Seite , - Richtung ) ;
    TurnRight ( Richtung * 90 )
  End
End ;

Procedure Dragon ( Grad , Seite : Integer ) ;

Begin
  If Grad = 0 Then
    Forwd ( Seite )
  Else
    If Grad > 0 Then
    Begin
      Dragon ( Grad - 1 , Trunc ( Seite ) ) ; TurnLeft ( 90 ) ;
      Dragon ( - ( Grad - 1 ) , Trunc ( Seite ) )
    End
    Else
    Begin
      Dragon ( - ( Grad + 1 ) , Trunc ( Seite ) ) ; TurnRight ( 90 ) ;
      Dragon ( Grad + 1 , Trunc ( Seite ) )
    End
End ;

Procedure Koch ( Grad , Seite : Integer ) ;

Begin
  If Grad = 0 Then
    Forwd ( Seite )
  Else
  Begin
    Koch ( Grad - 1 , Trunc ( Seite / 3 ) ) ; TurnRight ( 60 ) ;
    Koch ( Grad - 1 , Trunc ( Seite / 3 ) ) ; TurnLeft ( 120 ) ;
    Koch ( Grad - 1 , Trunc ( Seite / 3 ) ) ; TurnRight ( 60 ) ;
    Koch ( Grad - 1 , Trunc ( Seite / 3 ) )
  End
End ;

Procedure RechteckKoch ( Grad , Seite : Integer ) ;

Begin
  If Grad = 0 Then
    Forwd ( Seite )
  Else
  Begin
    RechteckKoch ( Grad - 1 , Trunc ( Seite / 3 ) ) ; TurnRight ( 90 ) ;
    RechteckKoch ( Grad - 1 , Trunc ( Seite / 3 ) ) ; TurnLeft ( 90 ) ;
    RechteckKoch ( Grad - 1 , Trunc ( Seite / 3 ) ) ; TurnLeft ( 90 ) ;
    RechteckKoch ( Grad - 1 , Trunc ( Seite / 3 ) ) ; TurnRight ( 90 ) ;
    RechteckKoch ( Grad - 1 , Trunc ( Seite / 3 ) )
  End
End ;

Procedure Kreuzstich ( Grad , Seite : Integer ) ;

Begin
  RechteckKoch ( Grad , Seite ) ; TurnRight ( 90 ) ;
  RechteckKoch ( Grad , Seite ) ; TurnRight ( 90 ) ;
  RechteckKoch ( Grad , Seite ) ; TurnRight ( 90 ) ;
  RechteckKoch ( Grad , Seite ) ; TurnRight ( 90 )
End ;

Procedure Schneeflocke ( Grad , Seite : Integer ) ;

Begin
  Koch ( Grad , Seite ) ; TurnLeft ( 120 ) ;
  Koch ( Grad , Seite ) ; TurnLeft ( 120 ) ;
  Koch ( Grad , Seite ) ; TurnLeft ( 120 )
End ;

Procedure CKurve ( Grad , Seite : Integer ) ;

Begin
  If Grad = 0 Then
    Forwd ( Seite )
  Else
  Begin
    CKurve ( Grad - 1 , Seite ) ; TurnLeft ( 90 ) ;
    CKurve ( Grad - 1 , Seite ) ; TurnRight ( 90 )
  End
End ;

Procedure Tree ( Grad , Seite : Integer ) ;

Begin
  If Grad > 0 Then
  Begin
    TurnRight ( 45 ) ;
    Forwd ( Seite ) ;
    Tree ( Grad - 1 , Trunc ( Seite / 2 ) ) ;
    Forwd ( - Seite ) ;
    TurnLeft ( 90 ) ;
    Forwd ( Seite ) ;
    Tree ( Grad - 1 , Trunc ( Seite / 2 ) ) ;
    Forwd ( - Seite ) ;
    TurnRight ( 45 )
  End
End ;

Procedure Zweig ( Grad , Seite , Winkel : Integer ) ;

Begin
  If Grad > 0 Then
  Begin
    TurnRight ( Winkel ) ;
    Forwd ( 2 * Seite ) ;
    Zweig ( Grad - 1 , Seite , Winkel ) ;
    Forwd ( - 2 * Seite ) ;
    TurnLeft ( 2 * Winkel ) ;
    Forwd ( Seite ) ;
    Zweig ( Grad - 1 , Seite , Winkel ) ;
    Forwd ( - Seite ) ;
    TurnRight ( Winkel )
  End
End ;

Function Zufall ( a , b : Integer ) : Integer ;

Begin
  Zufall := a + Random ( b - a + 1 )
End ;

Procedure ZufallZweig ( Grad , Seite , Winkel : Integer ) ;
VAR zu : INTEGER ;
Begin
  If Grad > 0 Then
  Begin
    TurnRight ( Winkel ) ;
    zu := Zufall ( Seite , Seite + 5 ) ;
    Forwd ( 2 * zu ) ;
    ZufallZweig ( Grad - 1 , Seite , Winkel ) ;
    Forwd ( - 2 * Zu ) ;
    TurnLeft ( 2 * Winkel ) ;
    Forwd ( Zu ) ;
    ZufallZweig ( Grad - 1 , Seite , Winkel ) ;
    Forwd ( - Zu ) ;
    TurnRight ( Winkel )
  End
End ;

PROCEDURE highvideo ;
  BEGIN
    textcolor (yellow);
  END ;
PROCEDURE normvideo ;
  BEGIN
    textcolor (lightgray);
  END ;
PROCEDURE lowvideo ;
  BEGIN
    textcolor (lightgray);
  END ;

Var Grad , Seite , Richtung , Winkel , Startx , Starty : Integer ;
    Ch , Druck : Char ;


Begin
  Repeat
    ClrScr ; Highvideo ;
    Write ( 'H' ) ; LowVideo ; Write ( 'ilbert, ' ) ; highvideo ;
    Write ( 'D' ) ; LowVideo ; Write ( 'ragon, ' ) ; highvideo ;
    Write ( 'K' ) ; LowVideo ; Write ( 'och , ' ) ; highvideo ;
    Write ( 'R' ) ; LowVideo ; Write ( 'echteckkoch, kreuzst' ) ; highvideo ;
    Write ( 'I' ) ; LowVideo ; Write ( 'ch, ' ) ; highvideo ;
    Write ( 'S' ) ; LowVideo ; WriteLn ( 'chneeflocke' ) ; highvideo ;
    Write ( 'C' ) ; LowVideo ; Write ( 'kurve , ' ) ; highvideo ;
    Write ( 'T' ) ; LowVideo ; Write ( 'ree  , ' ) ; highvideo ;
    Write ( 'Z' ) ; LowVideo ; Write ( 'weig, z' ) ; highvideo ;
    Write ( 'U' ) ; LowVideo ; Write ( 'fallszweig, ' ) ; highvideo ;
    Write ( 'E' ) ; LowVideo ; WriteLn ( 'nde' ) ; NormVideo ;
    WriteLn ; WriteLn ;
    Write ( 'Welche Kurve wird gewnscht ? ---> ' ) ;
    Repeat
      Ch := Upcase ( ReadKey ) ;
    Until Ch In ['H','D','K','R','I','S','C','T','Z','U','E'];
    WriteLn ( Ch ) ;
    If Not ( Ch = 'E') Then
    Begin
      WriteLn ; WriteLn ;
      Write ( 'Grad der Kurve ---------->  ' ) ; ReadLn ( Grad ) ;
      Write ( 'Seitenlnge ------------->  ' ) ; ReadLn ( Seite ) ;
      If Ch = 'H' Then
      Begin
        Write ( 'Richtung (1 oder -1) ---->  ' ) ; ReadLn ( Richtung )
      End ;
      If Ch In [ 'Z' , 'U' ] Then
      Begin
        Write ( 'Winkel ------------------>  ' ) ; ReadLn ( Winkel )
      End ;
      WriteLn ; WriteLn ;
      WriteLn ( 'Angabe des Startpunkts :' ) ;
      Write ( 'x-Koordinate ------------>  ' ) ; ReadLn ( Startx ) ;
      Write ( 'y-Koordinate ------------>  ' ) ; ReadLn ( Starty ) ;
      TurtleInit ;
      ClearDevice ;
      Delay ( 5000 ) ;
      SetPosition ( Startx , Starty ) ;
      Case Ch Of
        'H' , 'h' : Hilbert ( Grad , Seite , Richtung ) ;
        'D' , 'd' : Dragon ( Grad , Seite ) ;
        'K' , 'k' : Koch ( Grad , Seite ) ;
        'R' , 'r' : RechteckKoch ( Grad , Seite ) ;
        'I' , 'i' : KreuzStich ( Grad , Seite ) ;
        'S' , 's' : Schneeflocke ( Grad , Seite ) ;
        'C' , 'c' : CKurve ( Grad , Seite ) ;
        'T' , 't' : Tree ( Grad , Seite ) ;
        'Z' , 'z' : Zweig ( Grad , Seite , Winkel ) ;
        'U' , 'u' : ZufallZweig ( Grad , Seite , Winkel )
      End ;
      TurtleDone
    End
  Until Ch In [ 'E' , 'e' ]
End.
